Frobby::IdealConsumer Class Referenceabstract

This class provides a way to get monomial ideals as output from Frobby one generator at a time. More...

`#include <frobby.h>`

Inheritance diagram for Frobby::IdealConsumer:

## Public Member Functions

virtual | ~IdealConsumer ()
| The provided implementation does nothing.
virtual void | idealBegin (size_t varCount)
| Called before output of a monomial ideal.
virtual void | consume (mpz_ptr *exponentVector)=0
| For output of a generator of the ideal.
virtual void | idealEnd ()
| Called after output of a monomial ideal.

## Detailed Description

This class provides a way to get monomial ideals as output from Frobby one generator at a time.

Many computations performed by Frobby can produce output continously instead of having to wait for the computation to be done to be able to produce any output. Often the output can be processed, such as writing it to disk, as it is produced, and in these cases there is no reason to store all of the output before processing any of it. Often just storing the output can consume many times the amount of memory Frobby otherwise needs to carry out the computation.

Definition at line 75 of file frobby.h.

## Constructor & Destructor Documentation

## ~IdealConsumer()

Frobby::IdealConsumer::~IdealConsumer | ( |  | ) |

virtual

The provided implementation does nothing.

Definition at line 161 of file frobby.cpp.

## Member Function Documentation

## consume()

virtual void Frobby::IdealConsumer::consume | ( | mpz_ptr * | exponentVector | ) |

pure virtual

For output of a generator of the ideal.

exponentVector is an array containing the exponents of the generator.

The parameter exponentVector and its entries must not be altered or deallocated, and no reference to them can be retained after the consume method has returned. If the output must be stored, then a copy must be made.

Implemented in IrreducibleIdealDecoder, LibIdealConsumer, and LibIdealsConsumer.

## idealBegin()

void Frobby::IdealConsumer::idealBegin | ( | size_t | varCount | ) |

virtual

Called before output of a monomial ideal.

varCount is the number of variables of the ring within which the output ideal lies. The provided implementation does nothing.

Reimplemented in IrreducibleIdealDecoder, LibIdealConsumer, and LibIdealsConsumer.

Definition at line 164 of file frobby.cpp.

## idealEnd()

void Frobby::IdealConsumer::idealEnd | ( |  | ) |

virtual

Called after output of a monomial ideal.

The provided implementation does nothing.

Reimplemented in IrreducibleIdealDecoder.

Definition at line 167 of file frobby.cpp.

The documentation for this class was generated from the following files:

- src/frobby.h
- src/frobby.cpp